#include <cstdio>
#include <cmath>
#include <algorithm>
#include <cstring>
#include <vector>
#include <queue>
#include <set>
#include <map>
using namespace std;

struct pii
{
    long long fi, se, tr;
    bool operator<( const pii &x ) const
    {
        if ( fi != x.fi ) return fi < x.fi;
        if ( se != x.se ) return se < x.se;
        return tr < x.tr;
    }
};

pii makePii( long long f, long long s, long long t )
{
    pii a; a.fi = f; a.se = s; a.tr = t;
    return a;
}

set<pii> MP;

//set<pii> mp[8];
//set<ppii> mpp[8];

struct solut
{
    long long day, time, tar;
};

solut ms( long long d, long long ti, long long ta )
{
    solut s; s.day = d; s.time = ti; s.tar = ta;
    return s;
}

struct el
{
    long long v, t;
    long long d;
    bool operator<( const el& x ) const
    {
        return d > x.d;
    }
};

el mel( long long v, long long t, long long d )
{
    el e;
    e.v = v; e.t = t; e.d = d;
    return e;
}

struct ship
{
    long long b, s, pr, cap;
};

struct edge
{
    long long a, b, d, k;
};

struct flight
{
    long long s, e, mo, pr, cnt;
    long long di, to;
    long long id;
};

long long n, m, f;

ship sh[64];
edge e[1024];

long long laf;
flight fl[50020];

vector<long long> vf[64];

vector<long long> g[64];

long long len[64][64];

vector<solut> vb[64];

long long shcap;
long long gkor;

bool mycomp23( const long long &a, const long long &b )
{
    return fl[a].pr*min( fl[a].cnt, shcap) - sh[gkor].pr*fl[a].di > fl[b].pr*min( fl[b].cnt, shcap ) - sh[gkor].pr*fl[b].di;
}

vector<solut> sl;

bool notUsed( long long plan, long long tar, long long time )
{
        //if ( MP.find( make_pair( make_pair( plan, tar ), time ) ) != MP.end() )
        if ( MP.find( makePii( plan, tar, time ) ) != MP.end() )
            return 0;
        return 1;
    /*for ( long long i = 1; i <= 4; i++ )
    {
        //if ( i == clen ) continue;
        if ( mp[i].find( make_pair( make_pair( plan, tar ), time ) ) != mp[i].end() )
            return 0;
    }
    if ( mpp[clen].find( make_pair( day%(clen+1), make_pair( make_pair( plan, tar ), time ) ) ) == mpp[clen].end() )
        return 1;
    return 0;*/
}

void makeUsed( long long plan, long long tar, long long time )
{
    MP.insert( makePii( plan, tar, time ) );
    //mp[clen].insert( make_pair( make_pair( plan, tar ), time ) );
    //mpp[clen].insert( make_pair( day%(clen+1), make_pair( make_pair( plan, tar ), time ) ) );
}

void makeNotUsed( long long plan, long long tar, long long time )
{
    //MP.erase( make_pair( make_pair( plan, tar ), time ) );
    MP.erase( makePii( plan, tar, time ) );
    //mp[clen].erase( make_pair( make_pair( plan, tar ), time ) );
    //mpp[clen].erase( make_pair( day%(clen+1), make_pair( make_pair( plan, tar ), time ) ) );
}

void makeUsedFinal( long long v )
{
    long long cv = sh[v].b;
    for ( long long i = 1; i < (long long) vb[v].size(); i++ )
    {
        makeUsed( cv, vb[v][i].tar, vb[v][i].time );
        cv = vb[v][i].tar;
    }
}

bool canReach( long long kor, long long sv, long long sd, long long st, long long ev, long long clen )
{
    if ( st == 16 )
    {
        st = 4;
        sd++;
    }
    long long i, k;
    long long nd, nt;
    long long ad, at;
    if ( sd > clen ) return 0;
    if ( sv == ev ) return 1;
    //if ( canReach( kor, sv, sd, st+1, ev, clen ) ) return 1;
    for ( ; sd <= clen; sd++ )
    {
        for ( ; st < 16; st++ )
        {
            for ( i = 0; i < (long long)g[sv].size(); i++ )
            {
                k = g[sv][i];
                if ( ceil( (double)len[sv][k]/sh[kor].s ) + st < 16 )
                {
                    nd = sd;
                    nt = st;
                }
                else
                {
                    nd = sd+1;
                    nt = 4;
                }
                ad = nd;
                at = nt + ceil( (double)len[sv][k]/sh[kor].s );
                if ( at >= 16 ) continue;
                if ( notUsed( sv, k, nt ) )
                {
                    makeUsed( sv, k, nt );
                    if ( canReach( kor, k, ad, at, ev, clen ) )
                    {
                        makeNotUsed( sv, k, nt );
                        return 1;
                    }
                    makeNotUsed( sv, k, nt );
                }
            }
        }
    }
    return 0;
}

void greedy( long long kor, long long plan, long long mes, long long clen, long long cday, long long ctime )
{
//    printf( "GRRR %d %d %d %d %d %d __ %d\n", kor, plan, mes, clen, cday, ctime, sl.size() );
    if ( ctime == 16 )
    {
        greedy( kor, plan, mes, clen, cday+1, 4 );
        return;
    }
    if ( cday > clen ) return;
    if ( ( plan == sh[kor].b ) && ( cday > 0 || ctime > 4 ) && ( cday == clen ) )
    {
        if ( sl[0].tar > vb[kor][0].tar || vb[kor].size() == 1 )
        {
//            printf( "TUKA !!!! %d __ %d %d __ %d :: %d %d\n", kor, sl.size(), vb[kor].size(), sl[0].tar, cday, ctime );
            vb[kor] = sl;
        }
    }

    long long i, j, k;
    long long nd, nt;
    long long ad, at;

    shcap = sh[kor].cap;
    gkor = kor;
//    random_shuffle( vf[plan].begin(), vf[plan].end() );
    sort( vf[plan].begin(), vf[plan].end(), mycomp23 );

    for ( i = 0; i < (long long) vf[plan].size(); i++ )
    {
        j = vf[plan][i];
//        if ( fl[j].mo != mes ) continue;
        if ( fl[j].s < 4 ) continue;
        if ( fl[j].di <= (long long)(fl[j].e-fl[j].s)*sh[kor].s ) //mozhe da stigne
        {
            if ( ctime <= fl[j].s )
            {
                nd = cday;
                nt = fl[j].s;
            }
            else
            {
                nd = cday+1;
                nt = fl[j].s;
            }
            if ( notUsed( plan, fl[j].to, fl[j].s ) )
            {
                ad = nd;
                at = nt + ceil( (double)(fl[j].di)/(sh[kor].s) );
                if ( at >= 16 ) continue;
                if ( canReach( kor, fl[j].to, ad, at, sh[kor].b, clen ) )
                {
                    makeUsed( plan, fl[j].to, fl[j].s );
                    sl.push_back( ms( nd, nt, fl[j].to ) );
                    sl[0].tar = sl[0].tar + min( fl[j].cnt, sh[kor].cap )*fl[j].pr - sh[kor].pr*fl[j].di;

                    greedy( kor, fl[j].to, mes, clen, ad, at );

                    makeNotUsed( plan, fl[j].to, fl[j].s );
                    return;
                }
            }
        }
    }

    //justReach( kor, plan, cday, ctime, sh[kor].b, clen );
//    printf( "JUST REACH

    if ( i >= (int) vf[plan].size() )
    {
        for ( ; cday <= clen; cday++ )
        {
            for ( ; ctime < 16; ctime++ )
            {
                for ( i = 0; i < (int) g[plan].size(); i++ )
                {
                    k = g[plan][i];
                    if ( ceil( (double)len[plan][k]/sh[kor].s ) + ctime <= 16 )
                    {
                        nd = cday;
                        nt = ctime;
                    }
                    else
                    {
                        nd = cday+1;
                        nt = 4;
                    }
                    ad = nd;
                    at = nt + ceil( (double)len[plan][k]/sh[kor].s );
                    if ( at >= 16 ) continue;
                    if ( notUsed( plan, k, nt ) )
                    {
                        if ( canReach( kor, k, ad, at, sh[kor].b, clen ) )
                        {
                            makeUsed( plan, k, nt );
                            sl.push_back( ms( nd, nt, k ) );
                            sl[0].tar = sl[0].tar - sh[kor].pr*len[plan][k];

//                    printf( "TR %d %d + %d %d -> %d %d\n", nd, nt, fl[j].di, sh[kor].s, ad, at );

                            greedy( kor, k, mes, clen, ad, at );
                            makeNotUsed( plan, k, nt );
                            return;
                        }
                    }
                }
            }
        }
    }
}

void greedy( long long kor, long long mes, long long clen )
{
    greedy( kor, sh[kor].b, mes, clen, 1, 4 );
}

int main()
{
    long long i, j, k;

    FILE * fin = fopen( "flights.in", "r" );
    FILE * fout = fopen( "flights.out", "w" );

    memset( len, -1, sizeof( len ) );

    fscanf( fin, "%lld %lld %lld", &n, &m, &f );
    for ( i = 1; i <= m; i++ )
    {
        fscanf( fin, "%lld %lld %lld %lld", &sh[i].b, &sh[i].s, &sh[i].pr, &sh[i].cap );
    }

    laf = 0;
    for ( i = 1; i <= f; i++ )
    {
        fscanf( fin, "%lld %lld %lld %lld", &e[i].a, &e[i].b, &e[i].d, &e[i].k );

        g[ e[i].a ].push_back( e[i].b );
        len[ e[i].a ][ e[i].b ] = e[i].d;

        for ( j = 1; j <= e[i].k; j++ )
        {
            laf++;
            fl[ laf ].id = laf;
            fscanf( fin, "%lld %lld %lld %lld %lld", &fl[ laf ].s, &fl[ laf ].e, &fl[ laf ].mo, &fl[laf].pr, &fl[laf].cnt );
            vf[ e[i].a ].push_back( laf );
            fl[laf].di = e[i].d;
            fl[laf].to = e[i].b;
        }
    }

    for ( i = 1; i <= m; i++ ) //korab
    {
        vb[i].clear();
        vb[i].push_back( ms( -(1LL<<60), -(1LL<<60), -(1LL<<60) ) );
//        for ( k = 1; k <= 4; k++ ) //mesec
        {
            for ( j = 1; j <= 4; j++ ) //cycleLength
            {
                if ( n > 30 && j < 4 ) continue;
                sl.clear();
                sl.push_back( ms( j, 0, 0 ) );
                greedy( i, k, j );
            }
        }

        vb[i][0].day = vb[i][ vb[i].size()-1 ].day;
        makeUsedFinal( i );

    }

    for ( i = 1; i <= m; i++ )
    {
        fprintf( fout, "%d\n", vb[i].size()-1 );
        k = sh[i].b;
        for ( j = 1; j < (long long) vb[i].size(); j++ )
        {
            fprintf( fout, "%lld %lld %lld\n", vb[i][j].day, vb[i][j].time, vb[i][j].tar );
            k = vb[i][j].tar;

        }
    }
    return 0;
}
